Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.jasper
Class JspCompilationContext

    java.lang.Object
      org.apache.jasper.JspCompilationContext

public class JspCompilationContext
extends java.lang.Object

A place holder for various things that are used through out the JSP engine. This is a per-request/per-context data structure. Some of the instance variables are set at different points. Most of the path-related stuff is here - mangling names, versions, dirs, loading resources and dealing with uris.

Author:
  Anil K. Vijendran, Harish Prabandham, Pierre Delisle, Costin Manolache, Kin-man Chung

Constructor Summary
`JspCompilationContext(java.lang.String jspUri, boolean isErrPage, Options options, javax.servlet.ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt)`
`JspCompilationContext(java.lang.String tagfile, javax.servlet.jsp.tagext.TagInfo tagInfo, Options options, javax.servlet.ServletContext context, JspServletWrapper jsw, JspRuntimeContext rctxt, java.net.URL tagFileJarUrl)`

Method Summary
`void` | `compile()`
`Compiler` | `createCompiler()` Create a "Compiler" object based on some init param data.
`java.lang.String` | `getClassFileName()`
`java.lang.ClassLoader` | `getClassLoader()` What class loader to use for loading classes while compiling this JSP?
`java.lang.String` | `getClassPath()` The classpath that is passed off to the Java compiler.
`Compiler` | `getCompiler()`
`java.lang.String` | `getContentType()` Get the content type of this JSP.
`java.lang.String` | `getJavaPath()` Path of the Java file relative to the work directory.
`java.lang.String` | `getJspFile()` Path of the JSP URI.
`Options` | `getOptions()` Get hold of the Options object for this context.
`java.lang.String` | `getOutputDir()` The output directory to generate code into.
`java.lang.String` | `getRealPath(java.lang.String path)` Gets the actual path of a URI relative to the context of the compilation.
`java.net.URL` | `getResource(java.lang.String res)`
`java.io.InputStream` | `getResourceAsStream(java.lang.String res)` Gets a resource as a stream, relative to the meanings of this context's implementation.
`java.util.Set` | `getResourcePaths(java.lang.String path)`
`JspRuntimeContext` | `getRuntimeContext()`
`java.lang.String` | `getServletClassName()` Just the class name (does not include package name) of the generated class.
`javax.servlet.ServletContext` | `getServletContext()`
`java.lang.String` | `getServletJavaFileName()` Full path name of the Java file into which the servlet is being generated.
`java.lang.String` | `getServletPackageName()` Package name for the generated class is make up of the base package name, which is user settable, and the derived package name.
`java.net.URL` | `getTagFileJarUrl()` Returns the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.
`java.util.Hashtable` | `getTagFileJarUrls()` Returns the tag-file-name-to-JAR-file map of this compilation unit, which maps tag file names to the JAR files in which the tag files are packaged.
`javax.servlet.jsp.tagext.TagInfo` | `getTagInfo()`
`java.lang.String[]` | `getTldLocation(java.lang.String uri)` Gets the 'location' of the TLD associated with the given taglib 'uri'.
`ServletWriter` | `getWriter()` Where is the servlet being generated?
`void` | `incrementRemoved()`
`boolean` | `isErrorPage()` Are we processing something that has been declared as an errorpage?
`boolean` | `isPrototypeMode()` True if we are compiling a tag file in prototype mode.
`boolean` | `isRemoved()`
`boolean` | `isTagFile()`
`boolean` | `keepGenerated()` Are we keeping generated code around?
`java.lang.Class` | `load()`
`java.lang.String` | `resolveRelativeUri(java.lang.String uri)` Get the full value of a URI relative to this compilations context uses current file as the base.
`void` | `setClassLoader(java.net.URLClassLoader loader)`
`void` | `setClassPath(java.lang.String classPath)` The classpath that is passed off to the Java compiler.
`void` | `setContentType(java.lang.String contentType)`
`void` | `setErrorPage(boolean isErrPage)`
`void` | `setPrototypeMode(boolean pm)`
`void` | `setServletClassName(java.lang.String className)`
`void` | `setServletJavaFileName(java.lang.String servletJavaFileName)`
`void` | `setServletPackageName(java.lang.String servletPackageName)` The package name into which the servlet class is generated.
`void` | `setTagInfo(javax.servlet.jsp.tagext.TagInfo tagi)`
`void` | `setWriter(ServletWriter writer)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### JspCompilationContext

    public JspCompilationContext(java.lang.String jspUri,
                                 boolean isErrPage,
                                 Options options,
                                 javax.servlet.ServletContext context,
                                 JspServletWrapper jsw,
                                 JspRuntimeContext rctxt)

### JspCompilationContext

    public JspCompilationContext(java.lang.String tagfile,
                                 javax.servlet.jsp.tagext.TagInfo tagInfo,
                                 Options options,
                                 javax.servlet.ServletContext context,
                                 JspServletWrapper jsw,
                                 JspRuntimeContext rctxt,
                                 java.net.URL tagFileJarUrl)

Method Detail

### getClassPath

    public java.lang.String getClassPath()

  The classpath that is passed off to the Java compiler.

### setClassPath

    public void setClassPath(java.lang.String classPath)

  The classpath that is passed off to the Java compiler.

### getClassLoader

    public java.lang.ClassLoader getClassLoader()

  What class loader to use for loading classes while compiling this JSP?

### setClassLoader

    public void setClassLoader(java.net.URLClassLoader loader)

### getOutputDir

    public java.lang.String getOutputDir()

  The output directory to generate code into. The output directory is make up of the scratch directory, which is provide in Options, plus the directory derived from the package name.

### createCompiler

    public Compiler createCompiler()
                            throws JasperException

  Create a "Compiler" object based on some init param data. This is not done yet. Right now we're just hardcoding the actual compilers that are created.

  Throws:
    `JasperException`

### getCompiler

    public Compiler getCompiler()

### resolveRelativeUri

    public java.lang.String resolveRelativeUri(java.lang.String uri)

  Get the full value of a URI relative to this compilations context uses current file as the base.

### getResourceAsStream

    public java.io.InputStream getResourceAsStream(java.lang.String res)

  Gets a resource as a stream, relative to the meanings of this context's implementation.

  Returns:
    a null if the resource cannot be found or represented as an InputStream.

### getResource

    public java.net.URL getResource(java.lang.String res)
                             throws java.net.MalformedURLException

  Throws:
    `java.net.MalformedURLException`

### getResourcePaths

    public java.util.Set getResourcePaths(java.lang.String path)

### getRealPath

    public java.lang.String getRealPath(java.lang.String path)

  Gets the actual path of a URI relative to the context of the compilation.

### getTagFileJarUrls

    public java.util.Hashtable getTagFileJarUrls()

  Returns the tag-file-name-to-JAR-file map of this compilation unit, which maps tag file names to the JAR files in which the tag files are packaged. The map is populated when parsing the tag-file elements of the TLDs of any imported taglibs.

### getTagFileJarUrl

    public java.net.URL getTagFileJarUrl()

  Returns the JAR file in which the tag file for which this JspCompilationContext was created is packaged, or null if this JspCompilationContext does not correspond to a tag file, or if the corresponding tag file is not packaged in a JAR.

### getServletClassName

    public java.lang.String getServletClassName()

  Just the class name (does not include package name) of the generated class.

### setServletClassName

    public void setServletClassName(java.lang.String className)

### getJspFile

    public java.lang.String getJspFile()

  Path of the JSP URI. Note that this is not a file name. This is the context rooted URI of the JSP file.

### isErrorPage

    public boolean isErrorPage()

  Are we processing something that has been declared as an errorpage?

### setErrorPage

    public void setErrorPage(boolean isErrPage)

### isTagFile

    public boolean isTagFile()

### getTagInfo

    public javax.servlet.jsp.tagext.TagInfo getTagInfo()

### setTagInfo

    public void setTagInfo(javax.servlet.jsp.tagext.TagInfo tagi)

### isPrototypeMode

    public boolean isPrototypeMode()

  True if we are compiling a tag file in prototype mode. ie we only generate codes with class for the tag handler with empty method bodies.

### setPrototypeMode

    public void setPrototypeMode(boolean pm)

### getServletPackageName

    public java.lang.String getServletPackageName()

  Package name for the generated class is make up of the base package name, which is user settable, and the derived package name. The derived package name directly mirrors the file heirachy of the JSP page.

### setServletPackageName

    public void setServletPackageName(java.lang.String servletPackageName)

  The package name into which the servlet class is generated.

### getServletJavaFileName

    public java.lang.String getServletJavaFileName()

  Full path name of the Java file into which the servlet is being generated.

### setServletJavaFileName

    public void setServletJavaFileName(java.lang.String servletJavaFileName)

### getOptions

    public Options getOptions()

  Get hold of the Options object for this context.

### getServletContext

    public javax.servlet.ServletContext getServletContext()

### getRuntimeContext

    public JspRuntimeContext getRuntimeContext()

### getJavaPath

    public java.lang.String getJavaPath()

  Path of the Java file relative to the work directory.

### getClassFileName

    public java.lang.String getClassFileName()

### getContentType

    public java.lang.String getContentType()

  Get the content type of this JSP. Content type includes content type and encoding.

### setContentType

    public void setContentType(java.lang.String contentType)

### getWriter

    public ServletWriter getWriter()

  Where is the servlet being generated?

### setWriter

    public void setWriter(ServletWriter writer)

### getTldLocation

    public java.lang.String[] getTldLocation(java.lang.String uri)
                                      throws JasperException

  Gets the 'location' of the TLD associated with the given taglib 'uri'.

  Returns:
    An array of two Strings: The first element denotes the real path to the TLD. If the path to the TLD points to a jar file, then the second element denotes the name of the TLD entry in the jar file. Returns null if the given uri is not associated with any tag library 'exposed' in the web application.
  Throws:
    `JasperException`

### keepGenerated

    public boolean keepGenerated()

  Are we keeping generated code around?

### incrementRemoved

    public void incrementRemoved()

### isRemoved

    public boolean isRemoved()

### compile

    public void compile()
                 throws JasperException,
                        java.io.FileNotFoundException

  Throws:
    `JasperException`
    `java.io.FileNotFoundException`

### load

    public java.lang.Class load()
                         throws JasperException,
                                java.io.FileNotFoundException

  Throws:
    `JasperException`
    `java.io.FileNotFoundException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000 Apache Software Foundation. All Rights Reserved.